diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 000000000..3238b6c6a
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,44 @@
+# Sample systemd-user unit for `hive web` (Linux) — the managed local web
+# tier. This is a SEPARATE service from hive-daemon (the daemon and the web
+# UI are two independent units by design; never merge them).
+#
+# `hive web install` writes this file with ExecStart= and HIVE_BIN= rewritten
+# to the resolved `hive` binary, then enables + starts it. Manual install:
+#
+#   mkdir -p ~/.config/systemd/user
+#   cp examples/systemd/hive-web.service ~/.config/systemd/user/
+#   $EDITOR ~/.config/systemd/user/hive-web.service   # confirm ExecStart=
+#   systemctl --user daemon-reload
+#   systemctl --user enable --now hive-web
+#
+# Verify it started (a wrong ExecStart= shows up here as `failed`):
+#   systemctl --user status hive-web
+#   curl -fsS http://127.0.0.1:4567/health
+#
+# View logs:
+#   journalctl --user -u hive-web -f
+#
+# Stop / restart:
+#   systemctl --user stop hive-web        (or `hive web stop` / `hive web start`)
+
+[Unit]
+Description=Hive web UI (local mode)
+After=default.target
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+# HIVE_BIN pins the exact hive binary so a PATH change can never silently
+# drift the service onto a different install than the CLI that installed it
+# (`hive setup` detects and repairs that drift via a --force reinstall).
+Environment=HIVE_BIN=%h/.local/bin/hive
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+ExecStart=%h/.local/bin/hive web
+Restart=on-failure
+RestartSec=10s
+KillMode=mixed
+TimeoutStopSec=90
+
+[Install]
+WantedBy=default.target
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd8090689..5f4feed64 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -1332,10 +1332,102 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
+    desc "setup [PROJECT]", "Provision and validate the local stack: deps, web app, daemon service, enrollment, web UI"
+    long_desc <<~DESC
+      One command that brings up the local (non-Docker) Hive stack and
+      verifies it end to end:
+
+        1. preflight  — dependency report (Ruby 3.4, git, tmux, gh,
+                        claude, codex, Node/npm, qmd, bundler, SQLite).
+                        External agent CLIs are diagnose-only: the exact
+                        fix command is printed, nothing is ever installed
+                        or authenticated silently.
+        2. web_app    — resolve or provision the version-matched Rails
+                        web app under XDG data home.
+        3. daemon     — ensure the hive-daemon service runs THIS hive
+                        binary; drift is repaired via a --force reinstall.
+        4. enroll     — leave PROJECT (default: current directory)
+                        enrolled so new tasks dispatch automatically.
+                        Pass --all to enroll every registered project.
+        5. web        — start the managed web service and verify
+                        GET /health?deep=1, then print the URL
+                        (default http://127.0.0.1:4567).
+
+      Idempotent: re-running skips completed work. Each step can be skipped
+      with --skip-<step>. `--doctor-only` prints just the dependency
+      report. Port conflicts are reported with the owning process and FAIL
+      the run — hive never kills listeners and never silently picks
+      another port.
+
+      Exit code: 0 when every run step succeeded; 1 otherwise.
+    DESC
+    option :json, type: :boolean, default: false, desc: "emit the hive-setup.v1 step envelope on stdout"
+    option :"doctor-only", type: :boolean, default: false, desc: "run only the dependency report"
+    option :"skip-preflight", type: :boolean, default: false, desc: "skip the dependency preflight"
+    option :"skip-web-app", type: :boolean, default: false, desc: "skip web app resolution/provisioning"
+    option :"skip-daemon", type: :boolean, default: false, desc: "skip the daemon service guard"
+    option :"skip-enroll", type: :boolean, default: false, desc: "skip project enrollment"
+    option :"skip-web", type: :boolean, default: false, desc: "skip starting/verifying the web UI"
+    option :all, type: :boolean, default: false, desc: "enroll every registered project instead of PROJECT"
+    option :"unsafe-public", type: :boolean, default: false, hide: true
+    def setup(project = nil)
+      require "hive/commands/setup"
+      ok = Hive::Commands::Setup.new(
+        project: project,
+        json: options[:json],
+        doctor_only: options[:"doctor-only"],
+        skip_preflight: options["skip-preflight"],
+        skip_web_app: options["skip-web-app"],
+        skip_daemon: options["skip-daemon"],
+        skip_enroll: options["skip-enroll"],
+        skip_web: options["skip-web"],
+        enroll_all: options[:all],
+        unsafe_public: options["unsafe-public"]
+      ).call
+      exit 1 unless ok
+    end
+
+    desc "web SUBCOMMAND", "Run the hivebox web UI (bare / run: foreground; install / start / stop / status: managed service)"
     option :bind, type: :string, desc: "override web.bind"
     option :port, type: :numeric, desc: "override web.port"
-    def web
+    option :unsafe_public, type: :boolean, default: false,
+                           desc: "allow a non-loopback bind with auth mode none (explicit opt-in)"
+    option :force, type: :boolean, default: false,
+                   desc: "for install: overwrite an existing unit (saves <path>.bak)"
+    def web(subcommand = nil, *extra)
+      unless extra.empty?
+        raise Hive::InvalidTaskPath,
+              "hive web: unexpected arguments #{extra.inspect}; " \
+              "usage: hive web [install|start|stop|status|run]"
+      end
+
+      case subcommand
+      when nil, "run"
+        web_foreground
+      when "install"
+        require "hive/commands/web"
+        Hive::Commands::Web.new.install_service!(force: options[:force], json: options[:json])
+      when "start"
+        require "hive/commands/web"
+        Hive::Commands::Web.new.start_service!(json: options[:json])
+      when "stop"
+        require "hive/commands/web"
+        Hive::Commands::Web.new.stop_service!(json: options[:json])
+      when "status"
+        require "hive/commands/web"
+        Hive::Commands::Web.new(bind: options[:bind], port: options[:port])
+                           .service_status(json: options[:json])
+      else
+        raise Hive::InvalidTaskPath,
+              "hive web: unknown subcommand #{subcommand.inspect} " \
+              "(expected: install, start, stop, status, or bare/run for foreground)"
+      end
+    end
+
+    # Thor exposes public instance methods as commands — keep the
+    # foreground helper out of that surface entirely.
+    no_commands do
+      def web_foreground
       if options[:json]
         require "json"
         message = "hive web has no JSON output (it runs a long-lived server). " \
@@ -1355,7 +1447,9 @@ module Hive
       end
 
       require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(bind: options[:bind], port: options[:port],
+                              unsafe_public: options[:unsafe_public]).call
+      end
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 000000000..eea91eff9
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,398 @@
+require "fileutils"
+require "json"
+require "net/http"
+require "socket"
+require "yaml"
+
+require "hive/config"
+require "hive/paths"
+require "hive/commands/web"
+
+module Hive
+  module Commands
+    # `hive setup` — one command that provisions and validates the whole
+    # local (non-Docker) stack (U7), composing U2–U6:
+    #
+    #   1. preflight  — dependency report (U3); diagnose-only for external
+    #                   agent CLIs, hard-fails only on Ruby/git/bundle
+    #   2. web_app    — resolve or provision the version-matched Rails app
+    #                   (U2)
+    #   3. daemon     — ensure the daemon service runs THIS CLI binary
+    #                   (U5 guard; repair = daemon installer --force)
+    #   4. enroll     — leave the target project enrolled
+    #                   (daemon.enabled: true) so tasks dispatch (U6)
+    #   5. web        — start the managed web service (or detached
+    #                   fallback) and verify GET /health?deep=1, then print
+    #                   the URL (U4 + health probe)
+    #
+    # Idempotent: re-runs no-op completed steps. Every step is skippable
+    # (--skip-*) and reported in the hive-setup.v1 envelope. Port handling
+    # is truthful: if 4567 is already owned by another process we report
+    # the listener and FAIL the step — never kill, never silently pick an
+    # alternate port (the printed URL must be real).
+    class Setup
+      HEALTH_TIMEOUT_SEC = 30
+
+      StepResult = Struct.new(:name, :status, :detail, :fix, keyword_init: true)
+
+      attr_reader :steps
+
+      def initialize(project: nil, json: false, doctor_only: false,
+                     skip_preflight: false, skip_web_app: false, skip_daemon: false,
+                     skip_enroll: false, skip_web: false, enroll_all: false,
+                     unsafe_public: false,
+                     preflight: nil, guard: nil, provisioner: nil)
+        @project = project
+        @json = json
+        @doctor_only = doctor_only
+        @skip = {
+          "preflight" => skip_preflight,
+          "web_app" => skip_web_app,
+          "daemon" => skip_daemon,
+          "enroll" => skip_enroll || enroll_all,
+          "web" => skip_web
+        }
+        @enroll_all = enroll_all
+        @unsafe_public = unsafe_public
+        @preflight = preflight
+        @guard = guard
+        @provisioner = provisioner
+        @steps = []
+      end
+
+      def call
+        return doctor_only_run if @doctor_only
+
+        run_step("preflight") { step_preflight }
+        run_step("web_app") { step_web_app }
+        run_step("daemon") { step_daemon }
+        run_step("enroll") { step_enroll }
+        run_step("web") { step_web }
+
+        url = @steps.find { |s| s.name == "web" }&.status == "ok" ? web_url : nil
+        if @json
+          require "json"
+          puts JSON.generate(envelope(url))
+        else
+          render_summary(url)
+        end
+        @steps.none? { |s| s.status == "failed" }
+      end
+
+      def failed_steps
+        @steps.select { |s| s.status == "failed" }
+      end
+
+      private
+
+      def run_step(name)
+        if @skip[name]
+          @steps << StepResult.new(name: name, status: "skipped", detail: nil, fix: nil)
+          return
+        end
+
+        result = yield
+        @steps << result
+      rescue StandardError => e
+        @steps << StepResult.new(name: name, status: "failed", detail: "#{e.class}: #{e.message}", fix: nil)
+      end
+
+      # ── U3 ─────────────────────────────────────────────────────────
+      def step_preflight
+        report = (@preflight ||= build_preflight)
+        capture_stdout { report.call }
+        hard = report.hard_failures
+        warnings = report.warnings
+        rows_by_name = report.rows.group_by(&:name)
+
+        if hard.any?
+          detail = "missing/too old: #{hard.join(', ')}"
+          fixes = hard.map { |name| (rows_by_name[name].first&.fix || "").to_s }.compact.reject(&:empty?)
+          return StepResult.new(
+            name: "preflight", status: "failed", detail: detail,
+            fix: fixes.any? ? fixes.join("; ") : nil
+          )
+        end
+
+        detail = warnings.any? ? "warnings: #{warnings.join(', ')} (fix commands above)" : "all dependencies present"
+        StepResult.new(name: "preflight", status: "ok", detail: detail, fix: nil)
+      end
+
+      def build_preflight
+        require "hive/setup/preflight"
+        Hive::Setup::Preflight.new
+      end
+
+      # ── U2 ─────────────────────────────────────────────────────────
+      def step_web_app
+        cfg = Hive::Config.load_global_web
+        app_dir = web_app_dir || provision(cfg)
+        unless app_dir
+          return StepResult.new(
+            name: "web_app", status: "failed",
+            detail: "no Rails web app found and provisioning failed",
+            fix: "point HIVEBOX_WEB_APP_DIR at a web/ checkout matching this hive version"
+          )
+        end
+
+        StepResult.new(name: "web_app", status: "ok", detail: "app at #{app_dir}", fix: nil)
+      end
+
+      def web_app_dir
+        candidates = [
+          ENV["HIVEBOX_WEB_APP_DIR"],
+          File.expand_path("../../../web", __dir__)
+        ].compact
+        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+      end
+
+      def provision(_cfg)
+        (@provisioner ||= build_provisioner).provision
+      rescue Hive::Error => e
+        warn "hive setup: web app provisioning failed: #{e.message}"
+        nil
+      end
+
+      def build_provisioner
+        require "hive/web/app_provisioner"
+        Hive::Web::AppProvisioner.new
+      end
+
+      # ── U5 ─────────────────────────────────────────────────────────
+      def step_daemon
+        require "hive/setup/daemon_guard"
+        guard = (@guard ||= Hive::Setup::DaemonGuard.new)
+        result = guard.check
+
+        case result.status
+        when "unsupported"
+          StepResult.new(name: "daemon", status: "manual", detail: result.detail,
+                         fix: "run `hive daemon start` manually")
+        when "not_installed", "drifted"
+          outcome = capture_stdout { guard.repair! }
+          unless outcome.success?
+            return StepResult.new(name: "daemon", status: "failed",
+                                  detail: "daemon service install failed (#{outcome.wire_outcome})",
+                                  fix: "run `hive daemon install --force` manually")
+          end
+          post = guard.check
+          StepResult.new(
+            name: "daemon", status: post.status == "ok" ? "ok" : "failed",
+            detail: post.status == "ok" ?
+              "daemon unit pinned to #{post.service_binary} (was #{result.status}; repaired)" :
+              "repair ran but guard still reports #{post.status}",
+            fix: post.status == "ok" ? nil : "run `hive daemon install --force` manually"
+          )
+        else
+          detail = result.running ? "running (pid #{result.pid}), binary matches" : "binary matches; not currently running"
+          StepResult.new(name: "daemon", status: "ok", detail: detail, fix: nil)
+        end
+      end
+
+      # ── U6 ─────────────────────────────────────────────────────────
+      def step_enroll
+        if @enroll_all
+          require "hive/commands/daemon"
+          capture_stdout { Hive::Commands::Daemon.new("enable", nil, all: true, json: false).call }
+          return StepResult.new(name: "enroll", status: "ok", detail: "all registered projects enabled", fix: nil)
+        end
+
+        dir = File.expand_path(@project || ".")
+        entry = Hive::Config.project_for_path(dir)
+        if entry.nil?
+          require "hive/commands/init"
+          capture_stdout { Hive::Commands::Init.new(dir).call }
+          return StepResult.new(name: "enroll", status: "ok", detail: "initialised #{dir} (daemon enabled by default)", fix: nil)
+        end
+
+        cfg_path = File.join(entry.fetch("hive_state_path"), "config.yml")
+        enabled = project_daemon_enabled?(cfg_path)
+        if enabled == true
+          StepResult.new(name: "enroll", status: "ok", detail: "#{entry['name']} already enrolled", fix: nil)
+        elsif enabled.nil?
+          StepResult.new(name: "enroll", status: "failed", detail: "#{cfg_path} missing or unreadable",
+                         fix: "run `hive init #{dir}` to repair the project config")
+        else
+          require "hive/commands/daemon"
+          capture_stdout { Hive::Commands::Daemon.new("enable", entry.fetch("name"), json: false).call }
+          StepResult.new(name: "enroll", status: "ok", detail: "#{entry['name']} enrolled (daemon.enabled → true)", fix: nil)
+        end
+      end
+
+      def project_daemon_enabled?(cfg_path)
+        return nil unless File.file?(cfg_path)
+
+        data = YAML.safe_load_file(cfg_path) rescue nil
+        return nil unless data.is_a?(Hash)
+
+        data.dig("daemon", "enabled")
+      end
+
+      # ── Web launch + verification ──────────────────────────────────
+      def step_web
+        cfg = Hive::Config.load_global_web
+        bind = cfg.fetch("bind")
+        port = cfg.fetch("port").to_i
+
+        # Already-healthy web (our own service or a previous setup run) is
+        # a no-op — and must be checked BEFORE the port-conflict probe,
+        # since a running web legitimately owns the port.
+        if web_already_up?(bind, port)
+          detail = "already running"
+        else
+          owner = port_listener_pid(bind, port)
+          if owner
+            return StepResult.new(
+              name: "web", status: "failed",
+              detail: "port #{port} is already taken by pid #{owner[:pid]} (#{owner[:command]})",
+              fix: "stop that process or set web.port in the global config; hive never kills listeners and never silently moves ports"
+            )
+          end
+
+          require "hive/commands/web"
+          capture_stdout { Hive::Commands::Web.new.start_service!(json: false) }
+          detail = "started"
+        end
+
+        unless deep_health_ok?(bind, port)
+          return StepResult.new(
+            name: "web", status: "failed",
+            detail: "web did not become healthy at http://#{bind}:#{port}/health within #{HEALTH_TIMEOUT_SEC}s",
+            fix: "run `hive web` in the foreground to see the boot error"
+          )
+        end
+
+        StepResult.new(name: "web", status: "ok", detail: "#{detail}; healthy at #{web_url}", fix: nil)
+      end
+
+      def web_already_up?(bind, port)
+        require "hive/commands/web"
+        return true if Hive::Commands::Web.new.read_live_pid
+
+        quick_health_ok?(bind, port)
+      end
+
+      def web_url
+        cfg = Hive::Config.load_global_web
+        "http://#{cfg.fetch('bind')}:#{cfg.fetch('port')}"
+      end
+
+      # Who owns the port? Best-effort: try binding ourselves first (the
+      # common "free" case must not shell out); when occupied, ask lsof/ss
+      # where available. Never kills anything.
+      def port_listener_pid(bind, port)
+        begin
+          server = TCPServer.new(bind == "0.0.0.0" ? "0.0.0.0" : bind, port)
+          server.close
+          return nil
+        rescue Errno::EADDRINUSE
+          # fall through to identification
+        end
+
+        identify_listener(port)
+      end
+
+      def identify_listener(port)
+        %W[lsof -iTCP:#{port} -sTCP:LISTEN -P -n].then do |argv|
+          out = IO.popen(argv, &:read) rescue ""
+          if (match = out.match(/\S+\s+(\d+)\s+\S+\s+\S+\s*(.*)/))
+            pid = match[1]
+            command_line = begin
+              File.read("/proc/#{pid}/cmdline").tr("\0", " ").strip
+            rescue StandardError
+              match[2].to_s.strip
+            end
+            return { pid: pid, command: command_line.empty? ? "unknown" : command_line }
+          end
+        end
+        { pid: "unknown", command: "unknown listener" }
+      end
+
+      def deep_health_ok?(bind, port, timeout: HEALTH_TIMEOUT_SEC)
+        host = Hive::Commands::Web::LOOPBACK_BINDS.include?(bind) ? "127.0.0.1" : bind
+        deadline = Time.now + timeout
+        while Time.now < deadline
+          return true if one_health_probe_ok?(host, port)
+
+          sleep 0.5
+        end
+        false
+      end
+
+      def quick_health_ok?(bind, port)
+        host = Hive::Commands::Web::LOOPBACK_BINDS.include?(bind) ? "127.0.0.1" : bind
+        one_health_probe_ok?(host, port)
+      end
+
+      def one_health_probe_ok?(host, port)
+        response = Net::HTTP.start(host, port, open_timeout: 2, read_timeout: 5) do |http|
+          http.get("/health?deep=1")
+        end
+        response.is_a?(Net::HTTPSuccess)
+      rescue StandardError
+        false
+      end
+
+      # ── Reporting ──────────────────────────────────────────────────
+      def doctor_only_run
+        report = (@preflight ||= build_preflight)
+        capture_stdout { report.call }
+        ok = report.hard_failures.empty?
+        puts JSON.generate("schema" => "hive-setup-doctor",
+                           "schema_version" => 1,
+                           "ok" => ok,
+                           "rows" => report.rows.map do |row|
+                             { "name" => row.name, "status" => row.status,
+                               "message" => row.message, "fix" => row.fix,
+                               "required" => row.required }
+                           end) if @json
+        unless @json
+          report.render
+          if ok
+            puts "hive setup: preflight passed"
+          else
+            puts "hive setup: hard dependency failures — fix the rows marked missing/version_too_old above"
+          end
+        end
+        ok
+      end
+
+      def envelope(url)
+        {
+          "schema" => "hive-setup",
+          "schema_version" => 1,
+          "ok" => failed_steps.empty?,
+          "url" => url,
+          "steps" => @steps.map do |step|
+            { "name" => step.name, "status" => step.status,
+              "detail" => step.detail, "fix" => step.fix }
+          end
+        }.compact
+      end
+
+      def render_summary(url)
+        puts "hive setup:"
+        @steps.each do |step|
+          icon = { "ok" => "✔", "failed" => "✘", "manual" => "!", "skipped" => "·" }.fetch(step.status, "·")
+          line = "  #{icon} #{step.name}: #{step.status}"
+          line += " — #{step.detail}" if step.detail
+          puts line
+          puts "      fix: #{step.fix}" if step.fix
+        end
+        if url && failed_steps.empty?
+          puts ""
+          puts "  hive web is live at #{url}"
+        end
+      end
+
+      def capture_stdout
+        require "stringio"
+        original = $stdout
+        $stdout = StringIO.new
+        yield
+      ensure
+        $stdout = original
+      end
+    end
+  end
+end
